
package dialog;
import tm2.*;

import java.awt.*;
import mdgawt.*;
import java.awt.event.*;

public class PrefsDialog extends Dialog implements ActionListener{
      TMG tmg;
      public static Color boxBack = new Color(255,190,127);
      public static Color panelBack = Color.gray;
      UpDownCounter u1,u2;
      CCP c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13;
      CheckboxGroup cg = new CheckboxGroup();
      PMP pmp1,pmp2,pmp3;
      LP l;
      BorderPanel tp;
      Panel p2,p;
   public PrefsDialog(TMG t){
      super(t.myFrame,"Preferences",true);
      tmg=t;
      setSize(638,320);
      setResizable(false);
      setLocation(0,0);
      setLayout(new BorderLayout());
      tp = new BorderPanel();
      tp.setBackground(panelBack);
      tp.setLayout(new FlowLayout(1,20,20));
      p = new Panel();
         p.setLayout(new GridLayout(5,1,5,5));
         p.setBackground(boxBack);
         p.add(new LP("Auto Edit"));
         p.add(c1 = new CCP("Instructions",TMG.autoEditIns,true));
         p.add(c2 = new CCP("Text Boxes",TMG.autoEditText,true));
         p.add(c3 = new CCP("States",TMG.autoEditState,true));
         p.add(new LP(""));
         tp.add(p);
      p = new Panel();
         p.setLayout(new GridLayout(6,1,5,5));
         p.setBackground(boxBack);
         p.add(new LP("Organizer"));
         p.add(c4 = new CCP("Arrange states",false,false));
         p.add(c5 = new CCP("Arrange instructions",TMG.autoArrangeIns,true));
         p.add(c6 = new CCP("Retract text boxes",TMG.autoRetractText,true));
         p.add(c7 = new CCP("Reduce states",TMG.autoReduceStates,true));
         p.add(pmp3 = new PMP("Instruction gap",0,50,Ins.gap));
         tp.add(p);
      p = new Panel();
         p.setLayout(new GridLayout(5,1,5,5));
         p.setBackground(boxBack);
         p.add(new LP("Alphabet"));
         p.add(pmp1 = new PMP("Minimum",0,255,Alphabet.getMin()));
         p.add(pmp2 = new PMP("Maximum",0,255,Alphabet.getMax()));
         p.add(c8 = new CCP("Copy character",TMG.copysOn,true));
         p.add(c9 = new CCP("Wildcard character",TMG.wildcardsOn,true));
         tp.add(p);
         add("Center",tp);

      p = new Panel();
         p.setLayout(new GridLayout(5,1,5,5));
         p.setBackground(boxBack);
         p.add(new LP("Default Arc Type"));
         p.add(c10 = new CCP("Line",false,true,cg));
         p.add(c11 = new CCP("Bezier",false,true,cg));
         p.add(c12 = new CCP("Hermite",false,true,cg));
         if(Ins.defaultType == Ins.LINE)cg.setSelectedCheckbox(c10.cb);
         else if(Ins.defaultType == Ins.BARC)cg.setSelectedCheckbox(c11.cb);
         else if(Ins.defaultType == Ins.HARC)cg.setSelectedCheckbox(c12.cb);
         tp.add(p);

      Panel okc = new Panel();      
         okc.setBackground(panelBack);
         Button b = new Button("Ok");
         b.addActionListener(this);
         okc.add(b);
         b = new Button("Cancel");
         b.addActionListener(this);
         okc.add(b);
         add("South",okc);
      setVisible(true);}
   public void actionPerformed(ActionEvent e){
       Object c = e.getSource();
       char[] chars = new char[Tape.maxTapes];
       if (c instanceof Button){
         String command = ((Button)c).getLabel();
         if(command.equals("Ok")){
            Alphabet.setMin(pmp1.u.getValue());
            Alphabet.setMax(pmp2.u.getValue());
            TMG.autoEditIns   = c1.cb.getState();
            TMG.autoEditText  = c2.cb.getState();
            TMG.autoEditState = c3.cb.getState();
            TMG.autoArrangeIns= c5.cb.getState();
            TMG.autoRetractText= c6.cb.getState();
            TMG.autoReduceStates= c7.cb.getState();
            TMG.copysOn = c8.cb.getState();
            TMG.wildcardsOn = c9.cb.getState();
            Ins.gap = pmp3.u.getValue();
            String st = cg.getSelectedCheckbox().getLabel();
            if(st.equals("Line"))Ins.defaultType = Ins.LINE;
            else if(st.equals("Bezier"))Ins.defaultType = Ins.BARC;
            else if(st.equals("Hermite"))Ins.defaultType = Ins.HARC;
           dispose();}
         else if(command.equals("Cancel")){dispose();}
      }
   }
}

class BorderPanel extends Panel{
   public void paint(Graphics g) {
      super.paint(g);
      for(int i=0;i<getComponentCount();i++){
         Panel c = ((Panel)getComponent(i));
         Dimension d = c.getSize();d.width+=8;d.height+=8;
         Point p = c.getLocation();p.x-=4;p.y-=4;
         Color cc = PrefsDialog.boxBack.darker();
         g.setColor(Color.black);
         g.fillRoundRect(p.x-4,p.y-4,d.width+7,d.height+7,20,20);
         g.setColor(cc.darker().darker());
         g.fillRoundRect(p.x-3,p.y-3,d.width+5,d.height+5,20,20);
         g.setColor(cc.darker());
         g.fillRoundRect(p.x-2,p.y-2,d.width+3,d.height+3,20,20);
         g.setColor(cc);
         g.fillRoundRect(p.x-1,p.y-1,d.width+1,d.height+1,20,20);
         g.setColor(PrefsDialog.boxBack);
         g.fillRoundRect(p.x,p.y,d.width-1,d.height-1,20,20);}}
}

class CCP extends Panel{
   Checkbox cb;
   public CCP(String str,boolean b,boolean on,CheckboxGroup cg){
      setBackground(PrefsDialog.boxBack);
      cb = new Checkbox(str,b,cg);
      cb.setEnabled(on);
      cb.setBackground(PrefsDialog.boxBack);
      add(cb);}
   public CCP(String str,boolean b,boolean on){
      setBackground(PrefsDialog.boxBack);
      cb = new Checkbox(str,b);
      cb.setEnabled(on);
      cb.setBackground(PrefsDialog.boxBack);
      add(cb);}
}
class PMP extends Panel{
   UpDownCounter u;
   public PMP(String str,int min,int max,int curr){
      setBackground(PrefsDialog.boxBack);
      Label l = new Label(str);
      add(l);
      u = new UpDownCounter(min,max);
      u.setValue(curr);
      add(u);}
}
class LP extends Panel{
   public LP(String str){
      setBackground(PrefsDialog.boxBack);
      Label l = new Label(str);
      l.setBackground(PrefsDialog.boxBack);
      add(l);}
}


