
package mdgawt;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;
import java.io.*;

public class MyCanvas extends MyComponent implements WindowListener,
                                         MouseListener,MouseMotionListener{

// ----------------------------CLASS DATA------------------------------------
   public static Color graph            = new Color(0,0,0);
   public static Color grid             = new Color(0,0,0);
   public static int gridSize           = 16;
   public  static boolean debug         = false;
   public static boolean gridOn         = false;
   public static boolean snapToGridOn   = false;
   public static boolean dragLinksTo    = true;
   // Edit modes
   private static final int maxUndos          = 10;
   public  static final int NORMAL            = 0;
   public  static final int ADD_ARC_PHASE_ONE = 1;
   public  static final int ADD_ARC_PHASE_TWO = 2;
   public  static final int BINDING           = 3;
   public  static final int BOXING            = 4;
   public  static final int PASTING           = 5;
   public  static Vector copied;
// --------------------------INSTANCE DATA-----------------------------------
   public Vector undos = new Vector();
   protected MyPopup mpum;
   protected MenuBarWithEditMenu mbwm;
   public int editMode;
   protected MyComponent pick;
   protected BoxRunner boxRunner   = new BoxRunner();
   public Frame myFrame            = new Frame();
   protected ScrollPane sp         = new GSP();
   protected Vector myComps        = new Vector(10,10);
   protected Dimension lastSize    = new Dimension(100,100);
   protected Image b;   
   protected boolean closedPopup   = false;
   protected boolean hasBeenEdited = true;
   public boolean editedSinceSave = false;
   MyCanvasMover mcm;
   public int lastTime;
// ----------------------------CONSTRUCTOR-----------------------------------
   public MyCanvas(){
      sp.add(this);
      myFrame.setLayout(new BorderLayout());
      myFrame.add("Center",sp);
      myFrame.addWindowListener(this);      
      addMouseListener(this);
      addMouseMotionListener(this);
      mcm = new MyCanvasMover(this);}
// ------------------------------Move Components----------------------------
   public void moveComps(){
      Dimension d = getSize();
      for(int i=0;i<myComps.size();i++){
         MyComponent mc = getComp(i);
         Dimension s = mc.getSize();
         Point p = mc.getLocation();
         Point t = mc.getTravel();
         if(p.x+t.x+s.width>d.width || p.x+t.x<0)mc.travelx*=(-1);
         if(p.y+t.y+s.height>d.height|| p.y+t.y<0)mc.travely*=(-1);
         mc.setLocation(p.x+mc.travelx,p.y+mc.travely);}
      hasBeenEdited = true;
      paint(getGraphics());}
// ---------------------------------SAVE-------------------------------------
   public void save(PrintWriter out){
      MyComponent mc;
      out.println("<START>"); 
      for(int i=0;i<myComps.size();i++){
         mc = ((MyComponent)myComps.elementAt(i));
         out.println(mc.toString());
         if(mc.myChild !=null)mc.myChild.save(out);}                
      out.println("<LINKS>"); 
      for(int i=0;i<myComps.size();i++){   // save the links
         mc = ((MyComponent)myComps.elementAt(i)); 
         String str = new String(""+i+';');
         for(int j=0;j<mc.links.size();j++)
            str = new String(str + myComps.indexOf(mc.links.elementAt(j))+';');
         out.println(str);}
      out.println("<END>");}
// ---------------------------------LOAD-------------------------------------
   public MyComponent createFromString(String str){
      return null;}
//-------------------------------CASCADE-------------------------------------        
   public void cascade(int offset){
      for(int i=0;i<myComps.size();i++){
         MyComponent mc = ((MyComponent)myComps.elementAt(i));
         if(mc.myChild != null){
            if(mc.myChild.myFrame.isVisible()){
               mc.myChild.myFrame.setLocation(offset%400,offset%400);
               mc.myChild.myFrame.toFront();}
            mc.myChild.cascade(offset+25);}}}     
//--------------------------------SORT---------------------------------------
   public int firstInstanceOf(String type){
      for(int i=0;i<myComps.size();i++) 
         if(getComp(i).getClass().getName().equals(type))return i;
      return -1;}      
   public int lastInstanceOf(String type){
      for(int i=myComps.size()-1;i>=0;i--) 
         if(getComp(i).getClass().getName().equals(type))return i;
      return -2;}      
   public void sortByClass(){
      for(int i=0;i<myComps.size()-1;i++) 
         for(int j=0;j<myComps.size()-i-1;j++){
            MyComponent c = getComp(j);
            MyComponent n = getComp(j+1);
            if(c.getClass().getName().compareTo(n.getClass().getName())>0){
               myComps.setElementAt(n,j);
               myComps.setElementAt(c,j+1);}}}    
   public void sortByLinkText(int start,int end,int linkNum){
      if(debug)System.out.println("Sorting from "+start+" to "+end+" on link "+linkNum);
      if(end >= myComps.size())return;
      for(int i=start;i<=end-1;i++) 
         for(int j=start;j<=end-(i-start)-1;j++){
            MyComponent c = getComp(j);
            MyComponent n = getComp(j+1);
            if(debug)System.out.println("Comparing "+j+" and "+(j+1));
            if(linkNum<c.links.size()-1 && linkNum<n.links.size()-1){
               if(c.getLink(linkNum).toString().compareTo(
                                        n.getLink(linkNum).toString())>0){
               myComps.setElementAt(n,j);
               myComps.setElementAt(c,j+1);}}}}

//------------------------------OPEN ALL-------------------------------------        
   public void openAll(){
      for(int i=0;i<myComps.size();i++){
         MyComponent mc = getComp(i);
         if(mc.myChild != null){
            mc.myChild.myFrame.setVisible(true);
            mc.myChild.openAll();}}     
      cascade(25);}     
//------------------------------CLOSE ALL------------------------------------        
   public void closeAll(){
      if(debug)System.out.println("in MyCanvas:closeAll()");
      for(int i=0;i<myComps.size();i++){
         MyComponent mc = ((MyComponent)myComps.elementAt(i));
         if(mc.myChild != null){
            mc.myChild.myFrame.setVisible(false);
            mc.myChild.closeAll();}}}    
//------------------------------AUTO RESIZE-----------------------------------        
   public void minimizeCanvas(){
      int maxX=10,maxY=10,minX=4000,minY=4000;
      Point p;
      Dimension d;
      MyComponent mc;
      for(int i=0;i<myComps.size();i++){
         mc = ((MyComponent)myComps.elementAt(i));
         p=mc.getLocation();
         d=mc.getSize();
         if((p.x+d.width)>maxX)maxX=p.x+d.width;
         if((p.y+d.height)>maxY)maxY=p.y+d.height;
         if(p.x<minX)minX=p.x;
         if(p.y<minY)minY=p.y;}
      int xoff = minX-50;
      int yoff = minY-50;
//      System.out.println("xoff = "+xoff+"    yoff = "+yoff);
      for(int i=0;i<myComps.size();i++){
         mc = ((MyComponent)myComps.elementAt(i));
         p=mc.getLocation();
         mc.setLocation(p.x-xoff,p.y-yoff);} 
      setSize(Math.max(maxX-minX+100,200),Math.max(maxY-minY+100,200));}  
//-------------------------------COPY----------------------------------------
   public Vector copy(){
      if(!(boxRunner.isRunning))return null;
      Vector v = new Vector(4,4);
      for(int i=0;i<myComps.size();i++){
         MyComponent mc = getComp(i);
         if(mc.intersects(boxRunner))v.addElement(mc);}
      mbwm.enableEditMenu();
      return v;}
// --------------------------------REMOVE------------------------------------
   public void addUndo(Undo u){undos.addElement(u);}
   public void removeAll(){
      editedSinceSave = true;
      Vector temp = new Vector(4,4);
      for(int i=0;i<myComps.size();i++){
         MyComponent cc = getComp(i);
         if(!cc.isRemovable)temp.addElement(cc);}
      myComps = temp;}
   public void remove(MyComponent mc){
      editedSinceSave = true;
      if(debug)System.out.println("in MyCanvas:remove()");
      Undo u = new Undo("Delete State");
      remove(mc,u);
      addUndo(u);}
   public void remove(MyComponent mc,Undo undo){
      editedSinceSave = true;
      if(debug)System.out.println("in MyCanvas:remove2()");
      for(int i=0;i<myComps.size();i++)
      {
         MyComponent cc = getComp(i);
         if(cc==mc)
         {
            if(cc.myChild != null)
            {
               cc.myChild.closeAll();
               cc.myChild.myFrame.setVisible(false);
            }   
            myComps.removeElement(cc);
            removeAttached(cc,undo);
            undo.addElement(cc);
            i=0;
         } 
      }     
      fixData();
      fullRepaint();}
   protected void fixData(){}
   private void removeAttached(MyComponent mc,Undo u){
      editedSinceSave = true;
      if(debug)System.out.println("in MyCanvas:removeAttached()");
      if(debug)System.out.println("mc = "+mc.getClass());
      for(int i=0;i<myComps.size();i++){
         MyComponent mc2 = getComp(i); 
         if(mc2.isLinkedTo(mc)){
            if(!mc2.isRemovable)mc2.grabClosest();
            else{remove(mc2,u);i=0;}}
      }
   }
//-------------------------------DELETE-------------------------------------
   public Undo delete(){
      editedSinceSave = true;
      if(!(boxRunner.isRunning))return null;
      Undo undo = new Undo("Delete");
      for(int i=0;i<myComps.size();i++){
         MyComponent mc = getComp(i); 
         if(mc.intersects(boxRunner)){remove(mc,undo);i=0;}}
      return undo;}
//--------------------------------INTERSECT-------------------------------------        
   public MyComponent getClosest(String type,int xx,int yy){
      double bestDist = Double.MAX_VALUE;
      MyComponent bestComp = null;
      MyComponent currComp = null;
      for(int i=0;i<myComps.size();i++){
         currComp = getComp(i);
         if(currComp.getClass().getName().equals(type)){
            Point currPt = currComp.getLocation();
            double dist = Math.sqrt((currPt.x-xx)*(currPt.x-xx)+
                                    (currPt.y-yy)*(currPt.y-yy));
            if(dist<bestDist){bestDist=dist;bestComp=currComp;}
         }
      }  
      return bestComp; }
   public boolean intersects(MyComponent mc){
      for(int i=0;i<myComps.size();i++){
         MyComponent mc2 = getComp(i); 
         if(mc2.intersects(mc) && mc2!=mc)return true;}
      return false;}
// ----------------------------------ADD-------------------------------------
   protected MyComponent addMCNF(MyComponent mc){
      editedSinceSave = true;
      myComps.addElement(mc);
      mc.parent = this;
      if(debug)if(mc.parent==null)System.out.println("mc.parent=null");
      return mc;}
   public MyComponent addMC(MyComponent mc){
      editedSinceSave = true;
      myComps.addElement(mc);
      mc.parent = this;
      if(debug)if(mc.parent==null)System.out.println("mc.parent=null");
      fixData();
//      for(int i=0;i<myComps.size();i++)
//         System.out.println(getComp(i).getClass().getName());
      return mc;}
//----------------------------------FIND-------------------------------------        
   public MyComponent find(String type,String n){    
      for(int i=0;i<myComps.size();i++){
         if(getComp(i).getText().equals(n)) 
            return getComp(i);}
      return null;}
//--------------------------------LOCATE-------------------------------------        
   public MyComponent locateMC(int x,int y){
      if(mpum!=null)if(mpum.isInside(x,y))return mpum;
      MyComponent mc;
      for(int i=0;i<myComps.size();i++){
         mc = getComp(i); 
         if(mc.isVisible() && mc.isInside(x,y)){
            return mc;}}
      return null;}
//--------------------------------PRINT--------------------------------------
   public void print(){
      PrintJob pj =getToolkit().getPrintJob(myFrame,"test",new Properties());
      Graphics gg = pj.getGraphics();
      hasBeenEdited = true;
      if(gg==null)System.out.println("gg=====null");
      gg.setColor(Color.black);
 //     paint(gg);
 //     Dimension r = getSize();
 //     gg.setColor(graph);
 //     gg.fillRect(0, 0, r.width, r.height);
 //     gg.setColor(Color.black);
 //     gg.drawRect(0,0,r.width-1,r.height-1);
 //     for(int i=0;i<myComps.size();i++)getComp(i).paintLink(gg);
 //     for(int i=0;i<myComps.size();i++)getComp(i).paint(gg);
      gg.drawImage(b,0,0,this);
      gg.dispose();
      pj.end();}
// -------------------------------PAINT--------------------------------------
   public void fullRepaint(){hasBeenEdited=true;repaint();}
   public void update(Graphics g) {paint(g);}
   public void repaintAllGraphs(){
      fullRepaint();
      for(int i=0;i<myComps.size();i++){
         MyComponent cc = ((MyComponent)myComps.elementAt(i));
         if(cc.myChild != null)cc.myChild.repaintAllGraphs();}}  
   Image background;
   boolean backgroundOn=false;    
   public void paint(Graphics g){
      if(g==null)return;
      Dimension r = getSize();
      if(backgroundOn && background==null)getToolkit().getImage("theweb.gif");
      if(b==null || r.width!=lastSize.width || r.height!=lastSize.height){
//         if(b!=null){b.flush();System.gc();}
         hasBeenEdited = true;
         b = createImage(r.width+1,r.height+1);}
      lastSize=r;
      Graphics bg = b.getGraphics();
      if(hasBeenEdited){  // refill the buffer with new image
         bg.setColor(graph);
         if(backgroundOn && background==null)
            bg.drawImage(background,0,0,this);
         else bg.fillRect(0, 0, r.width, r.height);
         
         if(gridOn){
            bg.setColor(grid);
            for(int i=0;i<r.width;i+=gridSize)bg.drawLine(i,0,i,r.height);
            for(int i=0;i<r.height;i+=gridSize)bg.drawLine(0,i,r.width,i);}
         bg.setColor(Color.black);
         bg.drawRect(0,0,r.width-1,r.height-1);
         for(int i=0;i<myComps.size();i++)getComp(i).paintLink(bg);
         for(int i=0;i<myComps.size();i++)getComp(i).paint(bg);
      }
      if(mpum!=null)mpum.paint(bg);
      g.drawImage(b,0,0,this);
      hasBeenEdited = false;}
//-----------------------------METHODS---------------------------------------         
   public void setEditMode(int e){editMode=e;}
   public MyComponent getComp(int n){
      if(n<0 || n>=myComps.size())return null;
      return ((MyComponent)myComps.elementAt(n));}
   public void add(MyPopup c){mpum = ((MyPopup)c);}
   public Dimension getPreferredSize(){return new Dimension(getSize().width,getSize().height);}
   public Dimension getMinimumSize(){return getPreferredSize();}
   public void setGridSize(int s){editedSinceSave = true;gridSize=s;}
   public int getGridSize(){return gridSize;}

//-----------------------MOUSE MOTION EVENTS---------------------------------         
   public void mouseMoved(MouseEvent e){
      lastTime=0;
      if(mpum!=null)mpum.highlight(e.getX(),e.getY());
      if(editMode==PASTING){
         Graphics g = getGraphics();
         Dimension d = ((MyComponent)copied.elementAt(0)).getSize();
         paint(g);
         g.setColor(Color.black);
         g.drawRect(e.getX(),e.getY(),d.width,d.height);}
      else if(editMode!=NORMAL){
         Graphics g = getGraphics();
         paint(g);
         g.setColor(Color.black);
         g.drawLine(pick.getCenter().x,pick.getCenter().y,e.getX(),e.getY());}
   }
   public void mouseDragged(MouseEvent e){
      editedSinceSave = true;
      if(editMode==NORMAL){
         if(pick!=null){
            int pwd2  = pick.getSize().width/2;
            int phd2  = pick.getSize().height/2;
            int newx =Math.min(Math.max(e.getX()-pwd2,0),getSize().width-20);
            int newy =Math.min(Math.max(e.getY()-phd2,0),getSize().height-20); 
            int gsd2 = gridSize/2;
            if(snapToGridOn){
               newx=(int)((newx+pwd2+gsd2)/gridSize)*gridSize-pwd2;  
               newy=(int)((newy+phd2+gsd2)/gridSize)*gridSize-phd2; }
            Point p = pick.getLocation();
            int xoff = p.x-(newx);
            int yoff = p.y-(newy);
            MyComponent mt;
            for(int i=0;i<myComps.size();i++){  // drag link
               if((mt = getComp(i).getLink(0))==null)continue;
               if(mt==pick)getComp(i).translate(-xoff,-yoff);}
            pick.setLocation(newx,newy);
            fullRepaint();}
         else{
            boxRunner.setLocation(e.getX(),e.getY());
            boxRunner.setSize(0,0);
            editMode=BOXING;
            repaint();
            boxRunner.start(getGraphics());
            mbwm.enableEditMenu();
         }}
      else if(editMode==BOXING){ // draw the box
         Point p = boxRunner.getLocation();
         boxRunner.setSize(e.getX()-p.x,e.getY()-p.y);
         repaint();
      }
   }
//--------------------------MOUSE EVENTS-------------------------------------         
    public void mouseClicked(MouseEvent e){}
   public void mousePressed(MouseEvent e){
      if(mpum!=null){
         mpum.handleClosePopupEvent(e.getX(),e.getY());
         closedPopup = true;
         mpum = null;}
      else if(editMode==NORMAL)pick = locateMC(e.getX(),e.getY());
      if(boxRunner.isRunning){
         boxRunner.stop();
         mbwm.disableEditMenu();
      }
      fullRepaint();}
    public void mouseReleased(MouseEvent e){
      if(pick!=null){pick.grabClosest();}
      if(editMode==BOXING)editMode=NORMAL;}
    public void mouseEntered(MouseEvent e){}
    public void mouseExited(MouseEvent e){
       mpum = null;
       fullRepaint();}
//--------------------------WINDOW EVENTS--------------------------------         
   public void windowOpened(WindowEvent e){}
   public void windowClosing(WindowEvent e){}
   public void windowClosed(WindowEvent e){}
   public void windowIconified(WindowEvent e){}
   public void windowDeiconified(WindowEvent e){}
   public void windowActivated(WindowEvent e){}
   public void windowDeactivated(WindowEvent e){}
}

class MyCanvasMover implements Runnable{
// ---------------------------------RUN-------------------------------------
   MyCanvas mc;
   protected boolean isRunning = false;
   public boolean isMoving = false;
   protected Thread tt;
   protected int sleepDelay = 3600;
   public MyCanvasMover(MyCanvas m){mc=m;start();}
   public void start(){
      if(isRunning)stop();
      tt = new Thread(this);
      tt.start();}
   public void stop(){isRunning = false;}
   public void run(){
      isRunning = true;
      mc.lastTime = 0;
      while(isRunning){
         mc.lastTime++;
         if(mc.lastTime>sleepDelay){
            Vector v = new Vector();
            for(int i=0;i<mc.myComps.size();i++)
               v.addElement(mc.getComp(i).getLocation());
            isMoving=true;
            while(mc.lastTime!=0)mc.moveComps();
            isMoving=false;
            for(int i=0;i<mc.myComps.size();i++){
               Point p = ((Point)v.elementAt(i));
               mc.getComp(i).setLocation(p.x,p.y);}
            mc.fullRepaint();
         }
         try{Thread.sleep(1000);}
            catch(InterruptedException e){}
      }
   }
   protected void finalize() throws IOException{stop();}
}



