package mdgawt;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class MyPopup extends MyComponent{
// ----------------------------CLASS DATA------------------------------------
   public static Color back        = new Color(255,200,150);
   public static Color text        = new Color(0,0,0);
   public static Color highlight   = new Color(255,240,200);
   public static boolean isActive  = false;
   private Image b;
// --------------------------INSTANCE DATA-----------------------------------
   private int lineHeight;
   public Vector items = new Vector();
   public int selected = -1;
// ----------------------------CONSTRUCTOR-----------------------------------
   public MyPopup(MyCanvas c){parent = c;}
// ------------------------------METHODS-------------------------------------
   public void show(MyCanvas c,int xx,int yy){
      setLocation(xx,yy);
      parent.repaint();}
   public void handleClosePopupEvent(int xx,int yy){}
   public void highlight(int xx,int yy){
      if(isInside(xx,yy)){
         int index = (yy-getLocation().y)/lineHeight;
         if(index < items.size() && index >=0)
            selected = index;
         else selected = -1;}
      else selected = -1;
      Point p = getLocation();
      Dimension d = getSize();
      parent.repaint();}
   public String getItem(int xx,int yy){
      if(isInside(xx,yy)){
         int index = (yy-getLocation().y)/lineHeight;
         if(index < items.size() && index >=0)
            return ((String)items.elementAt(index));}
      return null;}
   public void addItem(String s){items.addElement(s);}
   private void setup(Graphics gg){
      int maxWidth = 0;
      if(gg==null)return;
      FontMetrics fm = gg.getFontMetrics();
      lineHeight = fm.getHeight();
      for(int i=0;i<items.size();i++){
         if(fm.stringWidth(((String)items.elementAt(i)))>maxWidth)
            maxWidth=fm.stringWidth(((String)items.elementAt(i)));}      
      setSize(maxWidth+8,fm.getHeight()*items.size()+1);}
// ------------------------------ PAINT--------------------------------------
   
   public void paint(Graphics g){
      if(g==null)return;
      setup(g);
      Point p = getLocation();
      Dimension d = getSize(); 
      Dimension id = parent.getSize();
      if(p.x+d.width>id.width)setLocation(p.x-d.width,p.y);
      if(p.y+d.height>id.height)setLocation(p.x,p.y-d.height);
      p = getLocation();
      g.setColor(back);         
      g.fillRoundRect(p.x,p.y,d.width,d.height-1,lineHeight,lineHeight);
      g.setColor(Color.black);
      g.drawRoundRect(p.x,p.y,d.width,d.height-1,lineHeight,lineHeight);
      if(selected>=0){
         g.setColor(highlight);       
         g.fillRoundRect(p.x,p.y+selected*lineHeight,d.width,lineHeight,lineHeight,lineHeight);
         g.setColor(Color.black);
         g.drawRoundRect(p.x,p.y+selected*lineHeight,d.width,lineHeight,lineHeight,lineHeight);}
      g.setColor(text);           
      for(int i=0,yoff=0;i<items.size();i++,yoff+=lineHeight)
         g.drawString(((String)items.elementAt(i)),p.x+4,p.y+(5*lineHeight)/6+yoff);
   }
}




 