
package mdgawt;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class UpDownCounter extends Panel implements Runnable,ItemListener,SettingItem{
// ---------------------------CLASS DATA-------------------------------------
   public final static int UP   = 1;
   public final static int DOWN = -1;
// --------------------------INSTANCE DATA-----------------------------------
   private boolean isRunning;
   private Vector listeners = new Vector(4,4);
   private int dir;
   private int min,max;
   private Thread tt;
   SmallCounter upw;
   PlusMinusButton plusButton,minusButton;
// ---------------------------CONSTRUCTOR------------------------------------
   public UpDownCounter(int minn,int maxx){
      min=minn;
      max=maxx;
      if(min<0)min=0;
      if(min>max){min=0;max=100;}
      setSize((Integer.toString(max).length()*6)+8+32,16);
      setLayout(new FlowLayout(0,0,0));
      plusButton  = new PlusMinusButton(PlusMinusButton.PLUS);
      plusButton.addItemListener(this);
      add(plusButton);
      upw = new SmallCounter(min,Integer.toString(max).length());
      add(upw);
      minusButton = new PlusMinusButton(PlusMinusButton.MINUS);
      minusButton.addItemListener(this);
      add(minusButton);}
   public void setColors(Color b,Color bn,Color c,Color cn){
      plusButton.button = minusButton.button =b; 
      plusButton.buttonSign = minusButton.buttonSign=bn;
      upw.setColors(c,cn);}
   public void setValue(int n){
      upw.num = n;
      upw.repaint();
      fireEvent();}
   public int getValue(){return upw.num;}
   public void update(Graphics g){paint(g);}
// --------------------------------RUN--------------------------------------
   public void start(){tt=new Thread(this);tt.start();}
   public void stop(){isRunning=false;upw.repaint();}
   public void run(){
      int delay=400;
      isRunning=true;
      while(isRunning){
         if(delay>0)delay=delay-delay/5;
         if(upw.num+dir<=max && upw.num+dir>=min)setValue(upw.num+dir);
         upw.repaint();
         try{Thread.sleep(delay+5-Math.min(((max-min)/200),5));}
            catch(InterruptedException e){} 
      }       
   }
// --------------------------SETTING ITEM------------------------------------
   public int getSetting(){return getValue();}
   public void addSettingListener(SettingListener l){listeners.addElement(l);}
   public void removeSettingListener(SettingListener l){listeners.removeElement(l);}
// ---------------------------FIRE EVENTS------------------------------------
   protected void fireEvent(){
      for(int i=0;i<listeners.size();i++)
         ((SettingListener)listeners.elementAt(i)).settingChanged(new SettingEvent
            (this,this));}
// ---------------------------ITEM EVENTS------------------------------------
   public void itemStateChanged(ItemEvent e){
      Object o = e.getItem();
      if(o instanceof PlusMinusButton){
         if(e.getStateChange()==ItemEvent.SELECTED){  
            if(((PlusMinusButton)o).getDirection()==PlusMinusButton.PLUS)dir=UP;
            else dir=DOWN;
            start();}
         else stop();
      }
   }
}

